JMAP Migration and Portability Extensions
Internet-Draft draft-ietf-jmap-portability-extensions-01
Joris Baum, Ed.
audriga
Alter Schlachthof 57
Karlsruhe
76137
Germany
joris@audriga.com
https://www.audriga.com
Hans-Joerg, Ed.
audriga
Alter Schlachthof 57
Karlsruhe
76137
Germany
hans-joerg@audriga.com
https://www.audriga.com
20 March 2024
Applications
JMAP
jmap
debug
logging
metadata
JMAP (RFC8620) is a generic, efficient, mobile friendly and scalable protocol that can be used for data of any type. This makes it a good fit for migrations or data portability use cases. This extension adds additional features useful (but not limited to) those use cases.
It adds a feature exposing details about the product, backend and environment of a JMAP server.
It also adds a data model for extending the JMAP Response with log messages, particularly helpful for debugging.
Introduction
Every server-side software has its own quirks. For example, a JMAP server might only have partially implemented the JMAP standard or design decisions might have been taken that let the server deviate from what is actually required by [RFC8620]. Servers might also have unintended bugs or have certain restrictions that are not sufficiently reflected by their list of supported server capabilities.
JMAP as a protocol for data migration and portability targets a large variety of pre-existing systems. Especially legacy systems often come with a lot of constraints that may prohibit them from fully complying with the JMAP standard. Interoperable clients that aim to have a successful structured data exchange with such "unique" servers need to handle these quirks with workarounds on the client-side. Clients only want to apply special workarounds in situations where they are truly necessary. This is typically done by identifying which server-side software they are communicating with.
JMAP does not provide a standardized way to retrieve an identifier of the product that is residing on the server side. Due to the lack of standardization clients are left to identify misbehaving servers by error-prone means. Examples are checking against a list of known URLs or checking known unique responses, typically only sent by certain products. This makes identifying products time-consuming and brittle.
Related functionality in other standards are the PRODID property in iCalendar [RFC5545] and vCard [RFC6350], which allows identifying the product that produced the files. ManageSieve [RFC5804] and JMAP Sieve [I-D.ietf-jmap-sieve] define an implementation property, which allows identifying the Sieve implementation.
Additionally, server-side logs are very valuable to analyze issues a client may run into. Usually, logs are either stored locally on the instances or sent to a dedicated logging server. However, data migrations often take place in constrained environments under which access to server-side logs is limited. JMAP can be leveraged to supply log messages along-side the usual data exchange. This also removes the need to operate a separate logging infrastructure or have dedicated channels for log messages.
Conventions Used In This Document
The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT", "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and "OPTIONAL" in this document are to be interpreted as described in BCP 14 [RFC2119] [RFC8174] when, and only when, they appear in all capitals, as shown here.
The definitions of JSON keys and datatypes in the document follow the conventions described in the core JMAP specification [RFC8620].
Addition to the capabilities object
The capabilities object is returned as part of the JMAP Session object; see [RFC8620], Section 2. This document defines two additional capability URIs.
urn:ietf:params:jmap:backendinfo
This extension defines one additional urn:ietf:params:jmap:backendinfo server capability that provides details about the product, backend, and environment.
The value of this property in the JMAP Session capabilities property is an object that MUST contain the following information on server capabilities:
- product: SoftwareInfo Information on the overall application or product.
- backend: SoftwareInfo|null Information on the JMAP API backend component.
- environment: SoftwareInfo|null Information on the environment the software is running in.
- capabilityOverrides: String[PatchObject]|null An object showing which capabilities use different software components. Each key is a URI for a capability supported by the server. The value for each of these keys is a Patch Object, see [RFC8620], Section 5.3, specifying differing information on software components.
The client MUST ignore any properties it does not understand.
A SoftwareInfo object has the following properties:
- name: String The name of the software.
- version: String The software version. The value MUST begin with a number. An example for an invalid value would be "v1.0.0".
This extension does not add anything to the account's accountCapabilities property.
Here is an example JSON snippet:
"capabilities": {
  "urn:ietf:params:jmap:core:backendinfo": {
    "backend": {
      "name": "OpenXPort/Horde",
      "version": "1.0.0"
    },
    "product": {
      "name": "Horde Webmailer",
      "version": "1.0.0"
    },
    "environment": {
      "name": "PHP",
      "version": "5.5"
    },
    "capabilityOverrides": {
      "urn:ietf:params:jmap:sieve": {
        "backend": {
          "name": "Cyrus timsieved",
          "version": "3.8.2"
        },
        "product": {
          "name": "Horde Ingo",
          "version": "1.0.0"
        }
      }
    }
  }
  ...
}

urn:ietf:params:jmap:debug
Represents support for the logs property in the JMAP method response (defined in [RFC8620] Section 3.4) and the "problem details" types (defined in [RFC8620] Section 3.6.1) using the LogLine data type.
The value of this property in the JMAP Session and account's capabilities property is an empty object.
Structured Data Exchange Extension
For clients signaling support for the "urn:ietf:params:jmap:core:backendinfo" capability, the Response object (see [RFC8620] Section 3.4) as well as all "problem details" objects (see [RFC8620] Section 3.6.1) will be extended via:
- logs: LogLine[] (optional) An array of log lines that were created while processing the request.
A LogLine object has the following properties:
- level: String The log level of the log message. MUST be one of the eight levels defined in RFC5424: debug, info, notice, warning, error, critical, alert or emergency.
- message: String The log message
- timestamp: UTCDate The date the log message was logged.
- class: String|null The name of the class that is currently logging.
- file: String|null The file that initiated the log line.
- line: String|null The exact line in the file where the log function is being called.
An example list of logs sent alongside a response to Core/echo would look like:
NOTE: '\' line wrapping per RFC 8792

{
  "using": [
    "urn:ietf:params:jmap:core","urn:ietf:params:jmap:debug"
  ],
  "methodCalls": [
    [
      "Core/echo",
      {
        "accountId": "jorissa",
        "someOtherKey": "someOtherValue"
      },
      "0"
    ]
  ]
}

{
  "logs": [
    {
      "file": "Logger.php",
      "level": "info",
      "line": 32,
      "message": "Array Logger has been successfully initialized",
      "timestamp": "2022-01-18T10:26:56+01:00"
    },
    {
      "file": "ErrorHandler.php",
      "level": "warning",
      "line": 52,
      "message": "fopen(bridge.php): failed to open stream: \
        No such file or directory",
      "timestamp": "2022-01-18T10:26:56+01:00"
    },
    ...
  ],
  "methodResponses": [
    [
      "Core/echo",
      {
        "someOtherKey": "someOtherValue",
        "accountId": "jorissa"
      },
      "0"
    ]
  ]
}

Security considerations
All security considerations of JMAP [RFC8620] apply to this specification.
Log messages might contain sensitive user data as well as detailed information about the system on which an API server has been installed. Appropriate measures must be taken to restrict access to JMAP Debug to trusted parties only.
IANA considerations
JMAP Capability Registration for "backendinfo"
IANA will register the "backendinfo" JMAP Capability as follows:
Capability Name: urn:ietf:params:jmap:backendinfo
Specification document: this document
Intended use: common
Change Controller: IETF
Security and privacy considerations: this document, Section 3.
JMAP Capability registration for "debug"
IANA is requested to register the "debug" JMAP Capability as follows:
Capability Name: urn:ietf:params:jmap:debug
Specification document: this document
Intended use: common
Change Controller: IETF
Security and privacy considerations: this document, Section 3.
JMAP Datatype Registration for "LogLine"
IANA will register the "LogLine" Data Type as folows:
Type Name: "LogLine"
Can reference blobs: No
Can use for state change: No
Capability: urn:ietf:params:jmap:debug
Reference: this document
Acknowledgements
Bron Gondwana, Neil Jenkins, Alexey Melnikov, Ken Murchison, Robert Stepanek and the JMAP working group at the IETF.
Normative References
[RFC8620]
[RFC5545]
[RFC6350]
[RFC5804]
[I-D.ietf-jmap-sieve]
[RFC2119]
[RFC8174]